<?php
/*********************************************************************************************
+ No Proxy Please v0.1 : A Plugin for MyBB 1.4 and 1.6
+ Free to Use
+ Free to Edit
+ But Not Allowed to distribute
**********************************************************************************************
*/
if(!defined("IN_MYBB")){
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");}
function no_proxy_info(){	return array(		"name"			=> "No Proxy Please",		"description"	=> "Deny any proxy from accessing your site.",		"website"		=> "http://yaldaram.com",		"author"		=> "Yaldaram",		"authorsite"	=> "http://yaldaram.com",		"version"		=> "0.1",		"compatibility" => "14*,16*"
	);
}
function no_proxy_activate(){
	global $db, $mybb;
	$no_proxy_group = array(		"gid"			=> "NULL",		"name"			=> "no_proxy",		"title" 		=> "No Proxy Please",		"description"	=> "Settings for the plugin.",		"disporder"		=> "1",		"isdefault"		=> "no",	);
	$db->insert_query("settinggroups", $no_proxy_group);
	$gid = $db->insert_id();
	
	$no_proxy_setting_1 = array(		"sid"			=> "NULL",		"name"			=> "no_proxy_global",		"title"			=> "Global Deny",		"description"	=> "Do you want to deny the Proxy access globally ?",		"optionscode"	=> "yesno",		"value"			=> "no",		"disporder"		=> "1",		"gid"			=> intval($gid),	);
	$db->insert_query("settings", $no_proxy_setting_1);
	$no_proxy_setting_2 = array(		"sid"			=> "NULL",		"name"			=> "no_proxy_reg",		"title"			=> "Registration Deny",		"description"	=> "Do you want to deny the Proxy access from registration ?",		"optionscode"	=> "yesno",		"value"			=> "yes",		"disporder"		=> "2",		"gid"			=> intval($gid),	);
	$db->insert_query("settings", $no_proxy_setting_2);
    rebuild_settings();
}
function no_proxy_deactivate(){
	global $db, $mybb;
	$db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='no_proxy'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='no_proxy_global'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='no_proxy_reg'");
    rebuild_settings();}
$plugins->add_hook("global_end", "no_proxy_global");
function no_proxy_global(){
	global $mybb, $session;
	if ($mybb->settings['no_proxy_global'] != "0")	{
		if ($_SERVER['HTTP_X_FORWARDED_FOR'] || $_SERVER['HTTP_X_FORWARDED'] || $_SERVER['HTTP_FORWARDED_FOR'] || $_SERVER['HTTP_CLIENT_IP'] || $_SERVER['HTTP_VIA'] || @fsockopen( $_SERVER['REMOTE_ADDR'], 80, $errstr, $errno, 1 ) || @fsockopen( $_SERVER['REMOTE_ADDR'], 443, $errstr, $errno, 1 )){
			error("Sorry, but you are not allowed to visit this website by using Proxy. If you feel this is an error, please email to the admin." , "Proxy Detected");
		}
	}
}
$plugins->add_hook("member_do_register_start", "no_proxy_reg");
function no_proxy_reg(){
	global $mybb, $session;
	if ($mybb->settings['no_proxy_reg'] != "0"){
		if ($_SERVER['HTTP_X_FORWARDED_FOR'] || $_SERVER['HTTP_X_FORWARDED'] || $_SERVER['HTTP_FORWARDED_FOR'] || $_SERVER['HTTP_CLIENT_IP'] || $_SERVER['HTTP_VIA'] || @fsockopen( $_SERVER['REMOTE_ADDR'], 80, $errstr, $errno, 1 ) || @fsockopen( $_SERVER['REMOTE_ADDR'], 443, $errstr, $errno, 1 )){
			error("Sorry, but you are not allowed to register on this website by using Proxy. If you feel this is an error, please email to the admin." , "Proxy Detected");
		}
	}
}
?>